package fr.aminelouveaau.cartes.model.api;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;
import fr.aminelouveaau.cartes.model.Card;
import fr.aminelouveaau.cartes.model.Number;
import fr.aminelouveaau.cartes.model.Shape;

import java.util.List;

public class SortingResult {
    private final List<Shape> shapeOrder;
    private final List<Number> numberOrder;
    private final List<Card> sortedCards;

    @JsonCreator
    public SortingResult(@JsonProperty("shapeOrder") List<Shape> shapeOrder,
                         @JsonProperty("numberOrder") List<Number> numberOrder,
                         @JsonProperty("sortedCards") List<Card> sortedCards) {
        this.shapeOrder = shapeOrder;
        this.numberOrder = numberOrder;
        this.sortedCards = sortedCards;
    }

    public List<Shape> getShapeOrder() {
        return shapeOrder;
    }

    public List<Number> getNumberOrder() {
        return numberOrder;
    }

    public List<Card> getSortedCards() {
        return sortedCards;
    }
}
