package fr.aminelouveaau.cartes.rest;

import fr.aminelouveaau.cartes.model.Card;
import fr.aminelouveaau.cartes.model.api.SortingResult;
import fr.aminelouveaau.cartes.service.GameService;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping({"/api", "/api/v0"})
public class GameResource {
    private final GameService gameService;


    public GameResource(GameService gameService) {
        this.gameService = gameService;
    }

    @RequestMapping(value = "deck:reset", method = RequestMethod.PUT)
    @ResponseBody
    public ResponseEntity resetGame() {
        gameService.createDeck();
        return new ResponseEntity<>(HttpStatus.OK);
    }

    @RequestMapping(value = "/deck/hand", method = RequestMethod.GET)
    @ResponseBody
    public List<Card> getCardHand() {
        return gameService.cardHand();
    }

    @RequestMapping(value = "/deck/hand:sort", method = RequestMethod.PUT)
    @ResponseBody
    public SortingResult sortHand(@RequestBody final List<Card> hand) {
        return gameService.sortHand(hand);
    }

}
